
#include "diskio.h"
#include "sd.h"
#include "spidma.h"
#include "malloc.h"


#define SD_CARD  0  //SD,Ϊ0
#define EX_FLASH 1  //ⲿflash,Ϊ1

#define FLASH_SECTOR_SIZE   512

//ʼ
DSTATUS disk_initialize (
    BYTE pdrv               /* Physical drive nmuber (0..) */
)
{
    u8 res=0;
    switch(pdrv)
    {
        case SD_CARD://SD
            res = SD_Initialize();//SD_Initialize()
            if(res)//STM32 SPIbug,sdʧܵʱִ,ܵSPIд쳣
            {
                SD_SPI_ReadWriteByte(0xff);//ṩ8ʱ
            }
            break;
        case EX_FLASH://ⲿflash
            break;
        default:
            res=1;
    }
    if(res)return  STA_NOINIT;
    else return 0; //ʼɹ
}

//ô״̬
DSTATUS disk_status (
    BYTE pdrv       /* Physical drive nmuber (0..) */
)
{
    return 0;
}

//
//drv:̱0~9
//*buff:ݽջ׵ַ
//sector:ַ
//count:Ҫȡ
DRESULT disk_read (
    BYTE pdrv,      /* Physical drive nmuber (0..) */
    BYTE *buff,     /* Data buffer to store read data */
    DWORD sector,   /* Sector address (LBA) */
    UINT count      /* Number of sectors to read (1..128) */
)
{
    u8 res=0;
    if (!count)return RES_PARERR;//countܵ0򷵻ز
    switch(pdrv)
    {
        case SD_CARD://SD
            res=SD_ReadDisk(buff,sector,count);
            if(res)//STM32 SPIbug,sdʧܵʱִ,ܵSPIд쳣
            {
                SD_SPI_ReadWriteByte(0xff);//ṩ8ʱ
            }
            break;
        case EX_FLASH://ⲿflash
            res=0;
            break;
        default:
            res=1;
    }
   //ֵSPI_SD_driver.cķֵתff.cķֵ
    if(res==0x00)return RES_OK;
    else return RES_ERROR;
}

//д
//drv:̱0~9
//*buff:׵ַ
//sector:ַ
//count:Ҫд
#if _USE_WRITE
DRESULT disk_write (
    BYTE pdrv,          /* Physical drive nmuber (0..) */
    const BYTE *buff,   /* Data to be written */
    DWORD sector,       /* Sector address (LBA) */
    UINT count          /* Number of sectors to write (1..128) */
)
{
    u8 res=0;
    if (!count)return RES_PARERR;//countܵ0򷵻ز
    switch(pdrv)
    {
        case SD_CARD://SD
            res=SD_WriteDisk((u8*)buff,sector,count);
            break;
        case EX_FLASH://ⲿflash
            res=0;
            break;
        default:
            res=1;
    }
    //ֵSPI_SD_driver.cķֵתff.cķֵ
    if(res == 0x00)return RES_OK;
    else return RES_ERROR;
}
#endif


//Ļ
 //drv:̱0~9
 //ctrl:ƴ
 //*buff:/ջָ
#if _USE_IOCTL
DRESULT disk_ioctl (
    BYTE pdrv,      /* Physical drive nmuber (0..) */
    BYTE cmd,       /* Control code */
    void *buff      /* Buffer to send/receive control data */
)
{
    DRESULT res;
    if(pdrv==SD_CARD)//SD
    {
        switch(cmd)
        {
            case CTRL_SYNC:
                SD_CS_L;
                if(SD_WaitReady()==0)res = RES_OK;
                else res = RES_ERROR;
                SD_CS_H;
                break;
            case GET_SECTOR_SIZE:
                *(WORD*)buff = 512;
                res = RES_OK;
                break;
            case GET_BLOCK_SIZE:
                *(WORD*)buff = 8;
                res = RES_OK;
                break;
            case GET_SECTOR_COUNT:
                *(DWORD*)buff = SD_GetSectorCount();
                res = RES_OK;
                break;
            default:
                res = RES_PARERR;
                break;
        }
    }
    else res=RES_ERROR;//Ĳ֧
    return res;
}
#endif
//ʱ
//User defined function to give a current time to fatfs module      */
//31-25: Year(0-127 org.1980), 24-21: Month(1-12), 20-16: Day(1-31) */
//15-11: Hour(0-23), 10-5: Minute(0-59), 4-0: Second(0-29 *2) */
DWORD get_fattime (void)
{
    return 0;
}


