/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2021/06/06
 * Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"
#include "spidma.h"
#include "sd.h"
#include "ff.h"

/* Global typedef */

/* Global define */

/* Global Variable */
//
FATFS fs;                     /* FatFsļϵͳ */
FIL fnew;                     /* ļ */
FRESULT res_sd;               /* ļ */
UINT fnum;                    /* ļɹд */
BYTE ReadBuffer[1024]={0};    /*  */
BYTE WriteBuffer[] =          /* д*/
"123456789123456789123456789123456789";

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    u32 sd_size;

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);

    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf("This is printf example\r\n");

    if(SD_Detect()==0)
    {
        printf("δSD!\n");
    }
    else
    {
        printf("ѼSD!\n");

        if(SD_Initialize())
        {
            printf("SDʼ飡!\n");
            Delay_Ms(500);
        }
        else
        {
            printf("SDʼɣ\n");
            sd_size=SD_GetSectorCount();//õ
            printf("SD Card SizeMB:%d\n",sd_size>>11);
        }
    }

    //ⲿSPI SDļϵͳļϵͳʱSPI豸ʼ
    res_sd = f_mount(&fs,"0:",1);

    /*----------------------- ʽ ---------------------------*/
    /* ûļϵͳ͸ʽļϵͳ */
    if(res_sd == FR_NO_FILESYSTEM)
    {
        printf("SDûļϵͳиʽ...\r\n");
    /* ʽ */
        res_sd=f_mkfs("0:",0,0);

        if(res_sd == FR_OK)
        {
            printf("SDѳɹʽļϵͳ\r\n");
      /* ʽȡ */
            res_sd = f_mount(NULL,"0:",1);
      /* ¹   */
            res_sd = f_mount(&fs,"0:",1);
        }
        else
        {
            printf("ʽʧܡres_sd =%d\r\n",res_sd);
            while(1);
        }
    }
    else if(res_sd!=FR_OK)
    {
        printf("SDļϵͳʧܡ(%d)\r\n",res_sd);
        printf("ԭSDʼɹ\r\n");
        while(1);
    }
    else
    {
        printf("ļϵͳسɹԽжд\r\n");
    }

    /*----------------------- ļϵͳԣд -----------------------------*/
    /* ļļ򴴽 */
    printf("\r\n****** ļд... ******\r\n");
    res_sd = f_open(&fnew, "0:WCH.txt", FA_OPEN_ALWAYS|FA_WRITE );
    if ( res_sd == FR_OK )
    {
        printf("/FatFsдļ.txtļɹļдݡ\r\n");
        /* ָ洢д뵽ļ */
        res_sd=f_write(&fnew,&WriteBuffer[0],sizeof(WriteBuffer),&fnum);
        if(res_sd==FR_OK)
        {
          printf("ļдɹдֽݣ%d\n",fnum);
          printf("ļдΪ\r\n%s\r\n",WriteBuffer);
        }
        else
        {
          printf("ļдʧܣ(%d)\n",res_sd);
        }
        //˴Ҫע⣬f_writef_closef_openȥߵһf_openԶдķʽһξͺ
        //FatfsļϵͳдTFȴдݵ
        f_close(&fnew);

    }
    else
    {
        printf("/ļʧܡ\r\n");
    }

    /*------------------- ļϵͳԣ --------------------------*/
    printf("****** ļȡ... ******\r\n");
    res_sd = f_open(&fnew, "0:WCH.txt",FA_OPEN_EXISTING | FA_READ);
    if(res_sd == FR_OK)
    {
        printf("ļɹ\r\n");
        res_sd = f_read(&fnew, ReadBuffer, sizeof(ReadBuffer), &fnum);
        if(res_sd==FR_OK)
        {
          printf("ļȡɹ,ֽݣ%d\r\n",fnum);
          printf("ȡõļΪ\r\n%s \r\n", ReadBuffer);
        }
        else
        {
          printf("ļȡʧܣ(%d)\n",res_sd);
        }
    }
    else
    {
        printf("ļʧܡ\r\n");
        printf("ļʧܣ(%d)\n",res_sd);
    }

    /* ٶдرļ */
    f_close(&fnew);

    /* ʹļϵͳȡļϵͳ */
    f_mount(NULL,"1:",1);


    while(1)
    {
    }
}
